
  <!DOCTYPE html>
  <html>
    <head>
      <title>Field.tsx</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/components/Field/Field.tsx</td><td class="">99.55%</td><td class="">80%</td><td class="">223</td><td class="">222</td><td class="">1</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import React, {
  useCallback,
  useLayoutEffect,
  useMemo,
  useRef,
  useState
} from &#x27;react&#x27;;
import clsx from &#x27;clsx&#x27;;

import s from &#x27;./Field.module.scss&#x27;;
import { BaseComponent } from &#x27;../../utils/BaseComponent&#x27;;
import { Input } from &#x27;../Input/Input&#x27;;

import eye from &#x27;./assets/eye.svg&#x27;;
import { ReactComponent as FileIcon } from &#x27;./assets/file.svg&#x27;;

export interface FieldProps extends BaseComponent {
  label: string;
  type?: &#x27;password&#x27; | &#x27;file&#x27;;
  size?: &#x27;large&#x27; | &#x27;medium&#x27; | &#x27;small&#x27;;
  accept?: string;
  fullWidth?: boolean;
  onUpload?: (file: File) =&gt; void;
  value?: string;
  onChange?: (value: string) =&gt; void;
}

const useFileInput = (
  onUpload?: (file: File) =&gt; void,
  skip?: boolean,
  accept?: string,
  setError?: (error: string) =&gt; void
) =&gt; {
  const inputRef = useRef&lt;HTMLInputElement&gt;(null);
  const fileInput = useMemo(() =&gt; {
    const hiddenFileInputField = document.createElement(&#x27;input&#x27;);
    hiddenFileInputField.type = &#x27;file&#x27;;
    if (accept) {
      hiddenFileInputField.accept = accept;
    }
    return hiddenFileInputField;
  }, [accept]);

  const handleUploadFile = useCallback(
    (file: File) =&gt; {
      const splitted = file.name.split(&#x27;.&#x27;);
      const ext = splitted[splitted.length - 1];
      if (!accept?.includes(ext)) {
        if (setError) {
          setError(`Avaliable extentions are ${accept?.split(&#x27;,&#x27;).join(&#x27;, &#x27;)}`);
        }

        return;
      } else {
        if (setError) {
          setError(&#x27;&#x27;);
        }
      }
      if (inputRef.current) {
        inputRef.current.value = file.name;
      }
      if (onUpload) {
        onUpload(file);
      }
    },
    [accept, onUpload, setError]
  );

  useLayoutEffect(() =&gt; {
    if (inputRef.current &amp;&amp; !skip) {
      const parent = inputRef.current.parentElement;
      if (parent) {
        const changeListener = (e: Event) =&gt; {
          const target = e.target as HTMLInputElement;
          const file = target.files?.[0];
          if (file) {
            handleUploadFile(file);
          }
        };
        fileInput.addEventListener(&#x27;change&#x27;, changeListener);
        return () =&gt; {
          fileInput.removeEventListener(&#x27;change&#x27;, changeListener);
        };
      }
    }
  }, [fileInput, handleUploadFile, skip]);

  return {
    onButtonClick: useCallback(() =&gt; {
      fileInput.click();
    }, [fileInput]),
    inputRef
  };
};
export const Field: React.FC&lt;FieldProps&gt; = ({
  size,
  type,
  className,
  label,
  fullWidth,
  onUpload,
  value,
  onChange,
  accept
}) =&gt; {
  const [isHide, setHide] = useState(true);
  const [error, setError] = useState(&#x27;&#x27;);
  const { inputRef, onButtonClick } = useFileInput(
    onUpload,
    type !== &#x27;file&#x27;,
    accept,
    setError
  );
  return (
    &lt;div className={clsx(className, s.Field, fullWidth &amp;&amp; s.Field_fullWidth)}&gt;
      &lt;div className={s.Field__label}&gt;{label}&lt;/div&gt;
      &lt;div className={s.Field__input}&gt;
        &lt;Input
          value={value}
          onChange={(e) =&gt; {
            if (onChange) {
              onChange(e.target.value);
            }
          }}
          error={error}
          ref={type === &#x27;file&#x27; ? inputRef : undefined}
          disabled={type === &#x27;file&#x27;}
          type={type === &#x27;password&#x27; &amp;&amp; isHide ? &#x27;password&#x27; : undefined}
          fullWidth={fullWidth}
          size={size}
          icon={
            type === &#x27;password&#x27; ? (
              &lt;img
                alt=&quot;password&quot;
                onClick={() =&gt; setHide((s) =&gt; !s)}
                src={eye}
              /&gt;
            ) : null
          }
          downPlaceholder={
            type === &#x27;password&#x27; ? (
              &lt;div className={s.forgotPassword}&gt;Forgot password?&lt;/div&gt;
            ) : type === &#x27;file&#x27; ? (
              &#x27;Files can include .csv, .xls, xlsx, .ambr&#x27;
            ) : null
          }
        /&gt;
        {type === &#x27;file&#x27; ? (
          &lt;button onClick={onButtonClick} className={s.Field__file}&gt;
            &lt;FileIcon /&gt;
          &lt;/button&gt;
        ) : null}
      &lt;/div&gt;
    &lt;/div&gt;
  );
};
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/components/Field/Field.tsx&quot;,&quot;line&quot;:73,&quot;character&quot;:25,&quot;text&quot;:&quot;e.target as HTMLInputElement&quot;,&quot;kind&quot;:3}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  